<div data-cy="apps-list" class="apps-panel-content">
  <ng-container *ngFor="let item of appList; trackBy: trackByAppId">
    <ng-container *ngIf="item.id !== preselectedApp || runningApps.get(item.id); else preselection">
      <app-app-item
        [appItem]="item"
        [selectedApp]="selectedApp"
        [expanded]="!!appExpansionDictionary[item?.id]"
        [appActive]="item.id === activeApp"
        [appRunning]="!!runningApps.get(item.id)"
        [hoveredNewApp]="hoveredNewApp === item.id"
        (itemSelected)="appPreselected.emit($event)"
        (closeApp)="closeApp.emit($event)"
        (expandApp)="expandApp.emit($event)"
        (collapseApp)="collapseApp.emit($event)">
      </app-app-item>
    </ng-container>
    <ng-template #preselection>
      <app-app-preselected
        [appItem]="item"
        (appSelected)="appSelected.emit($event)"
        (cancelSelected)="cancelSelected.emit()">
      </app-app-preselected>
    </ng-template>
  </ng-container>
  <ng-container *ngIf="!appList?.length && !selectionMissing">
    <div class="menu-no-content">
      <div>No apps have been added yet</div>
    </div>
    <div class="menu-no-content">
      <app-new-item-button
        [disabled]="disableNewButton"
        matTooltip="Apps can only be added to an open examination"
        [matTooltipDisabled]="!disableNewButton"
        (clicked)="addNewApp.emit($event)">
        + Add new App
      </app-new-item-button>
    </div>
  </ng-container>
  <ng-container *ngIf="selectionMissing">
    <app-missing-selection-error
      [missingSelectionType]="selectionMissing"
      (errorClicked)="errorClicked.emit($event)">
    </app-missing-selection-error>
  </ng-container>
</div>
